;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Activate Font
;
; Usage
;  LOAD "FONTS/"+F$+".BMP"+STR$ (8192+1024*B)
;       B$=Font[.chr] Name
;        B=Bank Number
;
;  PRINT USR BNKX;		Disable UDG font
;  PRINT USR BNKX;[BANK]	Enable  UDG font, Bank=0 to 7
;
;================================

ORG 4084

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A

@UDGx
	PUSH BC			;Save CALL address
	RST 20			;Get next character
	LD A,75			;Check for N/L
	INC A
	CP (HL)
	JR NZ GetBank
	POP BC			;Clear stack
	LD A,1E			;Standard IReg value
	JR NoPar		;Set IReg to 1E
@GetBank
	CALL Class6		;Evaluate [Bank] expression 
	CALL StackA		;A=Bank Number
	POP HL			;POP CALL address
	LD B,00			;
	ADD A,12		;Offset to table
	LD C,A			;BC=Offset to table
	ADD HL,BC		;HL=Pointer to IReg value
	LD A,(HL)		;A=IReg value
@NoPar
	LD I,A			;Set IReg
	RST 08			;Return
	FF
@IReg
	21 25 29 2D 31 35 39 3D
