;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Convert CHR$128 font to CHR$64 font
;
; PRINT USR C64X;[BANK]  Bank=0 to 7
;
;================================

ORG 4084

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A

@TableAddr
	LD HL,0007		;Offset to table
	ADD HL,BC		;HL=Table Address
	PUSH HL			;PUSH Table Address
	JR Comp			;Skip over table data
@Data
	20 24 28 2C 30 34 38 3C	;Hi byte of BANK address

@Comp
	RST 20			;Get next character
	LD A,75			;N/L test
	INC A
	CP (HL)
	JR Z NoPars		;Jump if no parameters
@GetBank
	CALL Class6		;Evaluate [BANK] expression
	CALL StackA		;A=Bank Number
	POP BC			;POP table address
	LD H,00			;
	LD L,A			;HL=Table offset
	ADD HL,BC		;HL=Pointer to BANK value
	LD H,(HL)		;H=Hi byte BANK address
	LD L,00			;HL=BANK address
	PUSH HL			;PUSH Bank address
	LD BC,0130		;Offset to lowercase characters
	ADD HL,BC		;HL=Lowercase address
	LD D,H
	LD E,L			;DE=Destination=Lowecase address
	INC H
	INC H			;HL=Source=Uppercase address
	LD BC,00D0		;Byte count, 26*8
	LDIR			;Copy Uppercase to Lowercase
	POP HL			;POP Bank address
	LD D,H
	LD E,C
	INC D
	INC D			;DE=Destination=CHR 128
	LD B,02			;Byte Count
	LDIR			;Copy 00 to 128
@NoPars
	RST 08			;Return
	FF