;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
; Compliment the BANK X characters
;
; PRINT USR INVX;[BANK],[X] Bank=0 to 7, X=0,1,2 All, Lowercase, Uppercase
;
;================================

ORG 4084

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A

@TableAddr
	LD HL,0007		;Offset to table
	ADD HL,BC		;HL=Table Address
	PUSH HL			;PUSH Table Address
	JR Comp			;Skip over table data
@Data
	20 24 28 2C 30 34 38 3C	;Hi byte of BANK address
;================================
@Comp
	RST 20			;Get next character
	LD A,75			;N/L test
	INC A
	CP (HL)
	JR Z NoPars		;Jump if no parameters
@GetBank
	CALL Class6		;Evaluate [BANK] expression
	CALL StackA		;A=Bank Number
	POP BC			;POP table address
	LD H,00			;
	LD L,A			;HL=Table offset
	ADD HL,BC		;HL=Pointer to BANK value
	LD H,(HL)		;H=Hi byte BANK address
	LD L,00			;HL=BANK address
	PUSH HL			;PUSH BANK address
@GetX
	RST 20 			;Get next character
	CALL Class6		;Evaluate [X] expression
	CALL StackA		;A=X value
	POP HL			;POP BANK address
	LD BC,03FF		;Byte count
	AND A			;A=0?
	JR NZ +2		;Jump if not 0
	JR Loop
	LD B,01			;Byte count
	DEC A			;A=1?
	JR Z +2
	INC H			;A=2+
	INC H			;HL=Uppercase address
@Loop
	LD A,(HL)		;Get data
	CPL			;Compliment the data
	LD (HL),A		;Set complimented data
	LD A,B			;Test counter
	OR C
	INC HL			;Increase pointer
	DEC BC			;Decrease counter
	JR NZ Loop		;Loop until BC=0
@NoPars
	RST 08			;Return
	FF