;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;Define UDG characters
;
; PRINT USR UDGX;[BANK],"[CHR X],80,80,82,82,FE,82,82,00,...[More UDG Pattern Definitions]"
;
;================================

@Class6=0D92			;Expression evaluator, if value>255 then error B
@StackA=0C02			;Move results to A
@BankX=403C			;Bank X address (PRBuff01)

;================================
@TableAddr
	LD HL,0007		;Offset to table
	ADD HL,BC		;HL=Table Address
	PUSH HL			;PUSH Table Address
	JR UDGX			;Skip over table data
@Data
	20 24 28 2C 30 34 38 3C	;Hi byte of BANK address
;================================
@UDGX
	RST 20			;Get next character
	LD A,75			;N/L test
	INC A
	CP (HL)
	JR Z Done		;Jump if no parameters
@GetBank
	CALL Class6		;Evaluate [BANK] expression
	CALL StackA		;A=Bank Number
	POP BC			;POP table address
	LD H,00			;
	LD L,A			;HL=Table offset
	ADD HL,BC		;HL=Pointer to BANK value
	LD H,(HL)		;H=Hi byte BANK address
	LD L,00			;HL=BANK address
	LD (BankX),HL		;Store Bank X address
	RST 20			;Get next character
	LD A,(HL)		;Check A value
	CP 0B			;Quote Mark?
	JR NZ Done		;Jump if not quote chr
	INC HL			;CHR X address
	LD A,(HL)		;Get CHR X
	BIT 7,A			;Graphic chr?
	INC HL			;Skip seperator
	PUSH HL			;PUSH data pointer, start of hex data
	LD HL,(BankX)		;Get Bank X address
	JR NZ Upper		;Jump if graphic chr
	AND A			;0 Test
	JR Z Code0		;Jump if 0
	JR CalcX		;Skip over Upper section
@Upper
	RES 7,A			;A=A-128
	LD HL,(BankX)		;Get Bank X address
	INC H
	INC H			;HL=Bank X+512
	AND A			;0 test
	JR Z Code0		;Jump if 0
@CalcX				;Calculate CHR X's address
	LD DE,0008		;Bytes/Chr
	LD B,A			;B=Counter
	ADD HL,DE
	DJNZ -3
@Code0
	POP DE			;POP data pointer
;==========================
@Chr2hex
	INC DE 			;Increase data pointer
	LD A,(DE)		;Process 1st hex chr
	SUB 1C 			;Convert to Decimal value
	LD B,A 			;B=Decimal value
	SLA B 			;Multiply by 16			
	SLA B 
	SLA B 
	SLA B 
	INC DE 			;Increase data pointer
	LD A,(DE)		;Process 2nd hex chr
	SUB 1C 			;Convert to Decimal value
	ADD A,B 		;Add 1st chr value
	LD B,A 			;B=final result
	LD (HL),B		;Set chr pattern
	INC HL			;Increase destination address
	INC DE 			;Increase data point
	LD A,(DE)		;Get data value
	CP 0B 			;" chr?
	JR NZ Chr2Hex		;Loop until " chr found
@Done
	RST 08
	FF